//+------------------------------------------------------------------+
//|                                                       Nikola.mq4 |
//|                                         Copyright  2011, ir0407 |
//|                                                 wlmaster@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, ir0407"
#property link      "wlmaster@mail.ru"

extern bool BuyEnable = True;
extern bool SellEnable = True;
extern int TakeProfit = 500;
extern double PO_Lots = 0.1;
extern int PO_Distance = 10;
extern int PO_StopLoss = 500;
extern bool TrailngEnable = False;
extern int TrailingStart = 10;
extern int TrailingStop = 10;
extern int TrailingStep = 3;
extern bool TrailngPOEnable = True;
extern int TrailingPOStop = 10;
extern int TrailingPOStep = 3;
extern int Magic = 12345;
extern bool OnTick = false; //     . 
extern bool CloseOrdersTime = true; //   
extern int StartTimeHours = 5; //    
extern int StopTimeHours = 21; //     
extern string c1=" :";
extern int TimeFrame = 0;// 0 -     .
extern int Rperiod=34;
extern int Draw4HowLongg=1500;


#include <stderror.mqh>
#include <stdlib.mqh>

datetime  NewBarOpenTime, LastTickTime;
extern bool Debug = False;
int tf[];


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   tf[0] = 0;    //  
   tf[1] = 1;    // 1  
   tf[2] = 5;    // 5  
   tf[3] = 15;   // 15 
   tf[4] = 30;   // 30 
   tf[5] = 60;   // 1  
   tf[6] = 240;  // 4  
   tf[7] = 1440; // 1  
   tf[8] = 10080;// 1   
   tf[9] = 43200;// 1   
  return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
  return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
  int TotalOrders, BuyOrders, SellOrders, BuyStopOrders, SellStopOrders, Ticket, Error;
  double NewSLPrice, BuyStopPrice, BuyStopSLPrice, SellStopPrice, SellStopSLPrice;
  double NewOpenPrice, NewTPPrice;
  
  LastTickTime = MarketInfo(Symbol(),MODE_TIME);
  TotalOrders = CountOfOrders();

  if(TotalOrders > 0)
  {
    BuyOrders      = CountOfBuy();
    SellOrders     = CountOfSell();
    BuyStopOrders  = CountOfBuyStop();
    SellStopOrders = CountOfSellStop();

    if(BuyEnable && SellEnable)
      if(BuyOrders == 0 && SellOrders == 0)
      {
        if(BuyStopOrders == 0 && SellStopOrders > 0)
        {
          Ticket = GetSellStopOrderTicket();
          DeletePendingOrder(Ticket, Error);
          return(0);
        }
        if(BuyStopOrders > 0 && SellStopOrders == 0)
        {
          Ticket = GetBuyStopOrderTicket();
          DeletePendingOrder(Ticket, Error);
          return(0);
        }
      }
    if(TrailngPOEnable)
    {
      if(BuyStopOrders > 0)
      {
        Ticket = GetBuyStopOrderTicket();
        if(OrderSelect(Ticket, SELECT_BY_TICKET) && OrderCloseTime() == 0)
          if(NormalizeDouble((OrderOpenPrice() - Ask) / Point, 0) > TrailingPOStop + TrailingPOStep)
          { // ,       TrailPendingOrder().
            NewOpenPrice = NormalizeDouble(Ask + TrailingPOStop * Point, Digits);
            NewTPPrice = NormalizeDouble(NewOpenPrice + TakeProfit * Point, Digits);
            NewSLPrice = NormalizeDouble(NewOpenPrice - PO_StopLoss * Point, Digits);
            TrailPendingOrder(NewOpenPrice, NewTPPrice, NewSLPrice, Error); // .
          }          
      }
      if(SellStopOrders > 0)
      {
        Ticket = GetSellStopOrderTicket();
        if(OrderSelect(Ticket, SELECT_BY_TICKET) && OrderCloseTime() == 0)
          if(NormalizeDouble((Bid - OrderOpenPrice()) / Point, 0) > TrailingPOStop + TrailingPOStep)
          { // ,       TrailPendingOrder().
            NewOpenPrice = NormalizeDouble(Bid - TrailingPOStop * Point, Digits);
            NewTPPrice = NormalizeDouble(NewOpenPrice - TakeProfit * Point, Digits);
            NewSLPrice = NormalizeDouble(NewOpenPrice + PO_StopLoss * Point, Digits);
            TrailPendingOrder(NewOpenPrice, NewTPPrice, NewSLPrice, Error); // .
          }
      }
    }      

    if(BuyOrders > 0)
    {
      Ticket = GetBuyOrderTicket();
      if(OrderSelect(Ticket, SELECT_BY_TICKET))
        if(OrderCloseTime() == 0)
          if(OrderStopLoss() < OrderOpenPrice())
          { // =0      .
            if(!((Bid - OrderOpenPrice()) / Point < TrailingStart))
              //if(OrderModify(Ticket, OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), 0))
              if(ModifyPriceTPSL(OrderOpenPrice(), OrderTakeProfit(), OrderOpenPrice(), Error))
              { //    Sell  SellStop 
                if(SellOrders > 0)
                {
                  Ticket = GetSellOrderTicket();
                  if(OrderSelect(Ticket, SELECT_BY_TICKET))
                    if(OrderCloseTime() == 0)
                      //OrderClose(Ticket, OrderLots(), NormalizeDouble(Ask, Digits),10);
                      CloseMarketOrder(Ticket, Error);
                }
                if(SellStopOrders > 0)
                {
                  Ticket = GetSellStopOrderTicket();
                  DeletePendingOrder(Ticket, Error);
                }
              }
          }
          else
            if(TrailngEnable)
            { // != 0,  
              if(NormalizeDouble((Bid - OrderStopLoss()) / Point, 0) > TrailingStop + TrailingStep)
              {
                NewSLPrice = NormalizeDouble(Bid - TrailingStop * Point, Digits);
                //OrderModify(OrderTicket(), OrderOpenPrice(), NewSLPrice, OrderTakeProfit(), 0, CLR_NONE);
                ModifyPriceTPSL(OrderOpenPrice(), OrderTakeProfit(), NewSLPrice, Error);

              }
            }
    }
    if(SellOrders > 0)
    {
      Ticket = GetSellOrderTicket();
      if(OrderSelect(Ticket, SELECT_BY_TICKET))
        if(OrderCloseTime() == 0)
          if(OrderStopLoss() > OrderOpenPrice())
          { // =0      .
            if(!((OrderOpenPrice() - Ask) / Point < TrailingStart))
            {
              Print("    #", Ticket);
              //if(OrderModify(Ticket, OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), 0))
              if(ModifyPriceTPSL(OrderOpenPrice(), OrderTakeProfit(), OrderOpenPrice(), Error))
              { //    Sell  SellStop 
                Print("  ,   ");
                if(BuyOrders > 0)
                {
                  Print("  Buy-.");
                  Ticket = GetBuyOrderTicket();
                  if(OrderSelect(Ticket, SELECT_BY_TICKET))
                    if(OrderCloseTime() == 0)
                      //OrderClose(Ticket, OrderLots(), NormalizeDouble(Bid, Digits),10);
                      CloseMarketOrder(Ticket, Error);
                }
                if(BuyStopOrders > 0)
                {
                  Print("  BuyStop-.");
                  Ticket = GetBuyStopOrderTicket();
                  DeletePendingOrder(Ticket, Error);
                }
              }
            }
          }
          else
            if(TrailngEnable)
            { // != 0,  
              if(NormalizeDouble((OrderStopLoss() - Ask) / Point, 0) > TrailingStop + TrailingStep)
              {
                NewSLPrice = NormalizeDouble(Ask + TrailingStop * Point, Digits);
                //OrderModify(OrderTicket(), OrderOpenPrice(), NewSLPrice, OrderTakeProfit(), 0, CLR_NONE);
                ModifyPriceTPSL(OrderOpenPrice(), OrderTakeProfit(), NewSLPrice, Error);
              }
            }
    }
  }
  if(StopTimeHours <= Hour() && CloseOrdersTime)
  {
    if(SellOrders > 0)
    {
     Print("  ");
     Ticket = GetSellOrderTicket();
     if(OrderSelect(Ticket, SELECT_BY_TICKET))
     if(OrderCloseTime() == 0) CloseMarketOrder(Ticket, Error);
    }
    if(SellStopOrders > 0)
    { 
      Print("  ");
      Ticket = GetSellStopOrderTicket();
      DeletePendingOrder(Ticket, Error);
    }
    if(BuyOrders > 0)
    {
      Print("  ");
      Ticket = GetBuyOrderTicket();
      if(OrderSelect(Ticket, SELECT_BY_TICKET))
         if(OrderCloseTime() == 0) CloseMarketOrder(Ticket, Error);
    }
    if(BuyStopOrders > 0)
    {
      Print("  ");
      Ticket = GetBuyStopOrderTicket();
      DeletePendingOrder(Ticket, Error);
    }
  }    
     
  
  TotalOrders = CountOfOrders();

  if (NewBarOpenTime == Time[0] && !OnTick) return (0);//   

  /*****************************************************************************/
  /*    ,        */ 
  /*****************************************************************************/
  double LSMA1=iCustom(NULL, tf[TimeFrame], "LSMA in Color",Rperiod,Rperiod,1,1);
  double LSMA2=iCustom(NULL, tf[TimeFrame], "LSMA in Color",Rperiod,Rperiod,2,1);
  double LSMA3=iCustom(NULL, tf[TimeFrame], "LSMA in Color",Rperiod,Rperiod,3,1);
//  Print ("LSMA1=",LSMA1,"   LSMA2=",LSMA2,"   LSMA3=",LSMA3);
  if (LSMA2==EMPTY_VALUE) 
  {
   BuyEnable = True;
   SellEnable = false;
  }
  if (LSMA1==EMPTY_VALUE)
  {
   BuyEnable = false;
   SellEnable = True;
  }
  
   BuyOrders      = CountOfBuy();
   SellOrders     = CountOfSell();

   if(BuyOrders > 0 && SellEnable)
   {
      Print("  Buy-.");
      Ticket = GetBuyOrderTicket();
      if(OrderSelect(Ticket, SELECT_BY_TICKET))
         if(OrderCloseTime() == 0)
            CloseMarketOrder(Ticket, Error);
            
   }    
   if(SellOrders > 0 && BuyEnable)
   {
      Print("  Sell-.");
      Ticket = GetSellOrderTicket();
      if(OrderSelect(Ticket, SELECT_BY_TICKET))
         if(OrderCloseTime() == 0)
            CloseMarketOrder(Ticket, Error);
   }
  
  
  if(TotalOrders > 0)
  {
   if(BuyEnable && BuyStopOrders == 0 && SellStopOrders > 0)
   {
      Ticket = GetSellStopOrderTicket();
      DeletePendingOrder(Ticket, Error);
   }    
   if(SellEnable && BuyStopOrders > 0 && SellStopOrders == 0)
   {
      Ticket = GetBuyStopOrderTicket();
      DeletePendingOrder(Ticket, Error);
   }
  }
  
  TotalOrders = CountOfOrders();

  NewBarOpenTime = Time[0];
  
  
  if(TotalOrders == 0 && StartTimeHours <= Hour() && StopTimeHours > Hour())
  {
    if(BuyEnable)
    {
      if(BuyStopOrders == 0 && SellStopOrders > 0)
      {
          Ticket = GetSellStopOrderTicket();
          DeletePendingOrder(Ticket, Error);
      }    
      BuyStopPrice = NormalizeDouble(Ask + NormalizeDouble(PO_Distance, 0) * Point, Digits);
      //BuyStopSLPrice = NormalizeDouble(BuyStopPrice - PO_StopLoss * Point, Digits);
      //OrderSend(Symbol(), OP_BUYSTOP, PO_Lots, BuyStopPrice, 10, BuyStopSLPrice, BuyStopPrice + TakeProfit * Point, "", Magic, 0,  Blue);
      
      SendPendingOrder(OP_BUYSTOP, PO_Lots, BuyStopPrice, TakeProfit, PO_StopLoss, Magic, "", Error);
    }
    if(SellEnable)
    {
      if(BuyStopOrders > 0 && SellStopOrders == 0)
      {
          Ticket = GetBuyStopOrderTicket();
          DeletePendingOrder(Ticket, Error);
      }
      SellStopPrice = NormalizeDouble(Bid - NormalizeDouble(PO_Distance, 0) * Point, Digits);
      //SellStopSLPrice = NormalizeDouble(SellStopPrice + PO_StopLoss * Point, Digits);
      //OrderSend(Symbol(), OP_SELLSTOP, PO_Lots, SellStopPrice, 10, SellStopSLPrice, SellStopPrice - TakeProfit * Point, "", Magic, 0, Red);
      SendPendingOrder(OP_SELLSTOP, PO_Lots, SellStopPrice, TakeProfit, PO_StopLoss, Magic, "", Error);
    }
  }
  return(0);
}

//+------------------------------------------------------------------+
int CountOfOrders()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol()) 
        if (OrderMagicNumber() == Magic) 
          if ((OrderType() == OP_SELL) || (OrderType() == OP_BUY) || (OrderType() == OP_BUYSTOP) || (OrderType() == OP_SELLSTOP)) 
            count++;
  return(count);
}

//+------------------------------------------------------------------+
int CountOfBuy()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
        if (OrderType() == OP_BUY) 
          count++;
  return(count);
}

//+------------------------------------------------------------------+
int CountOfSell()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
        if (OrderType() == OP_SELL) 
          count++;
  return(count);
}

//+------------------------------------------------------------------+
int CountOfBuyStop()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
        if (OrderType() == OP_BUYSTOP) 
          count++;
  return(count);
}

//+------------------------------------------------------------------+
int CountOfSellStop()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
        if (OrderType() == OP_SELLSTOP) 
          count++;
  return(count);
}

//+------------------------------------------------------------------+
int GetBuyOrderTicket()
{
  int Result = -1;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
        if (OrderType() == OP_BUY)
        {
          Result = OrderTicket(); 
          break;
        }
  return(Result);
}

//+------------------------------------------------------------------+
int GetSellOrderTicket()
{
  int Result = -1;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
        if (OrderType() == OP_SELL)
        {
          Result = OrderTicket(); 
          break;
        }
  return(Result);
}

//+------------------------------------------------------------------+
int GetBuyStopOrderTicket()
{
  int Result = -1;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
        if (OrderType() == OP_BUYSTOP)
        {
          Result = OrderTicket(); 
          break;
        }
  return(Result);
}

//+------------------------------------------------------------------+
int GetSellStopOrderTicket()
{
  int Result = -1;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
        if (OrderType() == OP_SELLSTOP)
        {
          Result = OrderTicket(); 
          break;
        }
  return(Result);
}

//+------------------------------------------------------------------+
bool TrailPendingOrder(double OpenPrice, double TPPrice, double SLPrice, int& Error)
{ 
  bool Result = False;
  if(Debug) Print(" TrailPendingOrder()");
  if(Debug) Print("   .");
  
  //     1
  if(OpenPrice == NormalizeDouble(OrderOpenPrice(), Digits) &&
     TPPrice == NormalizeDouble(OrderTakeProfit(), Digits) && 
     SLPrice == NormalizeDouble(OrderStopLoss(), Digits))
  {
    if(Debug)
    {
      Print("  .        1.");
      Print("OrderOpenPrice() = ", DoubleToStr(OrderOpenPrice(), 8), "; OpenPrice = ", OpenPrice);
      Print("OrderTakeProfit() = ", DoubleToStr(OrderTakeProfit(), 8),"; TPPrice = ", TPPrice);
    }
    Error = ERR_NO_RESULT; //   1
    return(False); //      
  }
  if(Debug) Print("     1  .");

  //  .  
  while(!IsStopped())
  {
    if(!IsExpertEnabled())
    {
      Print("    !");
      Error = ERR_TRADE_DISABLED;
      Result = False;
      break; //  while()
    }
    if(Debug) Print("  ");
    if(!IsConnected())
    {
      Print("   !");
      Error = ERR_NO_CONNECTION;
      Result = False;
      break; //  while()
    }
    if(Debug) Print("   ");
    if(IsTradeContextBusy())
    {
      if(Debug) Print("  !");
      Sleep(3000);
      RefreshRates();
      continue; //    while()
    }
    if(!IsTradeAllowed())
    {
      Print("  !     .");
      Result = False;
      break; //  while()
    }
    if(OrderModify(OrderTicket(), OpenPrice, SLPrice, TPPrice, 0, CLR_NONE))
    {
      Error = ERR_NO_ERROR;
      Result = True; 
      break; //  while()
    }
    else
    {
      Error = GetLastError();
      Result = False;
      break; //  while()
    }
  }
  if(Debug) Print("  TrailPendingOrder()");
  return(Result);
}

//+------------------------------------------------------------------+
//| ModifyTPPriceEx(double TPPrice, color UserColor, int& Err)       |
//+------------------------------------------------------------------+
bool ModifyPriceTPSL(double Price, double TPPrice, double SLPrice, int& Err)
{
  bool Result; int Error;
 
  //if(OrderSelect( Ticket, SELECT_BY_TICKET))
  //{
    if(Debug) Print(" ModifyTPPriceEx (  ", OrderTicket(),")"); 
    if(ModifyOrder(OrderTicket(), 
                   NormalizeDouble(Price, Digits), 
                   NormalizeDouble(SLPrice, Digits), 
                   NormalizeDouble(TPPrice, Digits), 
                   OrderExpiration(), Error))
    {
      Err = ERR_NO_ERROR;
      Result = True;
    }
    else
    {
      Err = Error;
      Result = False;
    }
  //}
  return(Result);
}

//+------------------------------------------------------------------+
//| ModifyOrder                                                      |
//+------------------------------------------------------------------+
bool ModifyOrder(int Ticket, double Price, double SLPrice, double TPPrice, datetime Exp, int& Err)
{
  bool Result; int Error;
  
  if(Debug) Print(" ModifyOrder");
  Result = False;
  while(!IsStopped())
  {
    if(!IsExpertEnabled())
    {
      Err = ERR_TRADE_DISABLED;
      Result = False;
      if(Debug) Print("  !  \"\" .");
      break;
    }
    if(Debug) Print("  .  \"\" .");
    if(IsTradeContextBusy())
    {
      if(Debug) Print("  !");
      Sleep(3000);
      continue;
    }
    if(Debug) Print("  ");
    if(!IsTradeAllowed())
    {
      Err = ERR_TRADE_NOT_ALLOWED;
      Result = False;
      if(Debug) Print("  !");
      break;
    }
    if(Debug) Print(" ,   #", Ticket);
    if(OrderModify(Ticket, Price, SLPrice, TPPrice, Exp))
    {
      Err = ERR_NO_ERROR;
      Result = True;
      if(Debug) Print("   ");
      break;
    }
    else
    {
      Error = GetLastError();
      Err = Error;
      Result = False;
      if(Debug) Print("   ");
      if(Debug) Print("(", Error, "): ", ErrorDescription(Error));
      break;
    }
  }
  return(Result);
}

//+------------------------------------------------------------------+
//| CloseMarketOrder                                                      |
//+------------------------------------------------------------------+
bool CloseMarketOrder(int Ticket, int& Err)
{
  int Error, Slippage; bool Delay = False;
  bool Result = False; double ClosePrice;
  color Color;

  if(OrderSelect(Ticket, SELECT_BY_TICKET))
    while(!IsStopped())
    {
      if(!IsExpertEnabled())
      {
        Err = ERR_TRADE_DISABLED;
        Print("  !  \"\" .");
        break;
      }
      if(Debug) Print("  ");
      if(!IsConnected())
      {
        Err = ERR_NO_CONNECTION;
        Print("   !");
        break;
      }
      if(Debug) Print("   ");
      if(Delay || MarketInfo(Symbol(), MODE_TIME) != LastTickTime) 
      {
        if(Debug) Print(" ");
        RefreshRates();
        LastTickTime = MarketInfo(Symbol(), MODE_TIME);
        Delay = False;
      }
      else
      {
        if(Debug) Print(" ");
      }
      switch(OrderType())
      {
      case OP_BUY:
        ClosePrice = NormalizeDouble(Bid, Digits);
        Color = Blue;
        break;
      case OP_SELL:
        ClosePrice = NormalizeDouble(Ask, Digits);
        Color = Red;
        break;
      }
      Slippage = MarketInfo(Symbol(), MODE_SPREAD);
      if(IsTradeContextBusy())
      {
        if(Debug) Print("  !");
        if(Debug) Print(" 3 ...");
        Sleep(3000);
        Delay = True;
        continue;
      }
      if(Debug) Print("  ");
      if(!OrderClose(Ticket, OrderLots(), ClosePrice, Slippage, Color))
      {
        Error = GetLastError();
        if (Error == 4   || // SERVER_BUSY 
            Error == 137 || // BROKER_BUSY 
            Error == 146 || // TRADE_CONTEXT_BUSY 
            Error == 136 )  // OFF_QUOTES 
        {
          if(Debug) Print("(OrderClose - ", Error, "): ", ErrorDescription(Error));
          if(Debug) Print(" 3 ...");
          Sleep(3000);
          Delay = True;
          continue;
        }
        else
        {
          if(Debug) Print(" (OrderClose - ", Error, "): ", ErrorDescription(Error));
          Err = Error;
          break;
        }
      }
      else
      {
        Result = True;
        Err = ERR_NO_ERROR;
        if(Debug) Print("  #", Ticket, "  .");
        break;
      }
    }
  return(Result);  
}

bool DeletePendingOrder(int Ticket, int& Err)
{
  bool Result; int Error;
  
  if(Debug) Print(" DeletePendingOrder()");
  Result = False;
  while(!IsStopped())
  {
    if(!IsExpertEnabled())
    {
      Err = ERR_TRADE_DISABLED;
      Print("  !  \"\" .");
      break;
    }
    if(Debug) Print("  ");
    if(!IsConnected())
    {
      Err = ERR_NO_CONNECTION;
      Print("   !");
      break;
    }
    if(Debug) Print("   ");
    if(IsTradeContextBusy())
    {
      if(Debug) Print("  !");
      if(Debug) Print(" 3 ...");
      Sleep(3000);
      continue;
    }
    if(!IsTradeAllowed())
    {
      Err = ERR_TRADE_NOT_ALLOWED;
      Result = False;
      if(Debug) Print("  !");
      break;
    }
    if(Debug) Print(" ,   #", Ticket);
    if(!OrderDelete(Ticket))
    {
      Error = GetLastError();
      if (Error == 4   || // SERVER_BUSY 
          Error == 137 || // BROKER_BUSY 
          Error == 146 || // TRADE_CONTEXT_BUSY 
          Error == 136 )  // OFF_QUOTES 
      {
        if(Debug) Print("(DeletePendingOrder - ", Error, "): ", ErrorDescription(Error));
        if(Debug) Print(" 3 ...");
        Sleep(3000);
        continue;
      }
      else
      {
        if(Debug) Print(" (DeletePendingOrder - ", Error, "): ", ErrorDescription(Error));
        Err = Error;
        break;
      }
    }
    else
    {
      Result = True;
      Err = ERR_NO_ERROR;
      if(Debug) Print("  #", Ticket, "  .");
      break;
    }
  }
  return(Result);  
}

//+------------------------------------------------------------------+
//| SendMarketOrder(int Type, double Lots, int TP, int SL, int Magic, string Cmnt, int& Err)
//+------------------------------------------------------------------+
int SendPendingOrder(int Type, double Lots, double POPrice, int TP, int SL, int Magic, string Cmnt, int& Error)
{
  double Price, Take, Stop;
  int Ticket, Slippage, Color, Err; 
  bool Delay = False;
  if(Debug) Print(" SendPendingOrder");
  while(!IsStopped())
  {
    if(!IsExpertEnabled())
    {
      Error = ERR_TRADE_DISABLED;
      Print("  !");
      return(-1);
    }
    if(Debug)Print("  ");
    if(!IsConnected())
    {
      Error = ERR_NO_CONNECTION;
      Print(" !");
      return(-1);
    }
    if(Debug)Print("   ");
    if(IsTradeContextBusy())
    {
      Print("  !");
      Print(" 3 ...");
      Sleep(3000);
      Delay = True;
      continue;
    }
    if(Debug)Print("  ");
    if(Delay) 
    {
      if(Debug)Print(" ");
      RefreshRates();
      Delay = False;
    }
    else
    {
      if(Debug)Print("  ");
    }
    switch(Type)
    {
      case OP_BUYSTOP:
        if(Debug)Print("   BUYSTOP -");
        Price = NormalizeDouble(POPrice, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble(Price + TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble(Price - SL * Point, Digits));
        Color = Blue;
        break;
      case OP_SELLSTOP:
        if(Debug)Print("   SELLSTOP-");
        Price = NormalizeDouble( POPrice, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble(Price - TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble(Price + SL * Point, Digits));
        Color = Red;
        break;
      default:
        if(Debug)Print("    .");
        return(-1);
    }
    Slippage = MarketInfo(Symbol(), MODE_SPREAD);
    if(Debug)Print("Slippage = ",Slippage);
    if(IsTradeAllowed())
    {
      if(Debug)Print(" ,  ...");
      Ticket = OrderSend(Symbol(), Type, Lots, Price, Slippage, Stop, Take, Cmnt, Magic, 0, Color);
      if(Ticket < 0)
      {
        Err = GetLastError();
        if (Err == 4   || /* SERVER_BUSY */
            Err == 130 || /* INVALID_STOPS */ 
            Err == 135 || /* PRICE_CHANGED */ 
            Err == 137 || /* BROKER_BUSY */ 
            Err == 138 || /* REQUOTE */ 
            Err == 146 || /* TRADE_CONTEXT_BUSY */
            Err == 136 )  /* OFF_QUOTES */
        {
          Print("(OrderSend - ", Err, "): ", ErrorDescription(Err));
          Print(" 3 ...");
          Sleep(3000);
          Delay = True;
          continue;
        }
        else
        {
          Print(" (OrderSend - ", Err, "): ", ErrorDescription(Err));
          Error = Err;
          break;
        }
      }
      break;
    }
    else
    {
      Print("      !");
      Print(" 3 ...");
      Sleep(3000);
      Delay = True;
      continue;
    }
  }
  if(Debug)Print("  .  = ",Ticket);
  return(Ticket);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| IIFd(bool condition, double ifTrue, double ifFalse)              |
//+------------------------------------------------------------------+
double IIFd(bool condition, double ifTrue, double ifFalse) 
{
  if (condition) return(ifTrue); else return(ifFalse);
}

